VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2040
      TabIndex        =   2
      Top             =   600
      Width           =   615
   End
   Begin VB.TextBox txtDir 
      Height          =   285
      Left            =   840
      TabIndex        =   1
      Text            =   "C:\Windows"
      Top             =   120
      Width           =   3735
   End
   Begin VB.Label lblDirSize 
      Height          =   255
      Left            =   840
      TabIndex        =   3
      Top             =   1080
      Width           =   3735
   End
   Begin VB.Label Label1 
      Caption         =   "Directory"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' Return the number of bytes used by this directory.
' This does not include subdirectories.
Private Function DirSize(ByVal dir_name As String) As Double
Dim total_size As Double
Dim file_name As String

    If Right$(dir_name, 1) <> "\" Then dir_name = dir_name & "\"

    file_name = Dir$(dir_name)
    Do While Len(file_name) > 0
        total_size = total_size + FileLen(dir_name & file_name)
        file_name = Dir$()
    Loop

    DirSize = total_size
End Function
Private Sub cmdGo_Click()
    Screen.MousePointer = vbHourglass
    DoEvents

    lblDirSize.Caption = FormatBytes(DirSize(txtDir.Text))

    Screen.MousePointer = vbDefault
End Sub

' Return a formatted string representing the number of
' bytes.
Private Function FormatBytes(ByVal num_bytes As Double) As String
Const ONE_KB As Double = 1024
Const ONE_MB As Double = ONE_KB * 1024
Const ONE_GB As Double = ONE_MB * 1024
Const ONE_TB As Double = ONE_GB * 1024
Const ONE_PB As Double = ONE_TB * 1024
Const ONE_EB As Double = ONE_PB * 1024
Const ONE_ZB As Double = ONE_EB * 1024
Const ONE_YB As Double = ONE_ZB * 1024
Dim value As Double
Dim txt As String

    ' See how big the value is.
    If num_bytes <= 999 Then
        ' Format in bytes.
        FormatBytes = Format$(num_bytes, "0") & " bytes"
    ElseIf num_bytes <= ONE_KB * 999 Then
        ' Format in KB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_KB) & " KB"
    ElseIf num_bytes <= ONE_MB * 999 Then
        ' Format in MB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_MB) & " MB"
    ElseIf num_bytes <= ONE_GB * 999 Then
        ' Format in GB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_GB) & " GB"
    ElseIf num_bytes <= ONE_TB * 999 Then
        ' Format in TB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_TB) & " TB"
    ElseIf num_bytes <= ONE_PB * 999 Then
        ' Format in PB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_PB) & " PB"
    ElseIf num_bytes <= ONE_EB * 999 Then
        ' Format in EB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_EB) & " EB"
    ElseIf num_bytes <= ONE_ZB * 999 Then
        ' Format in ZB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_ZB) & " ZB"
    Else
        ' Format in YB.
        FormatBytes = ThreeNonZeroDigits(num_bytes / _
            ONE_YB) & " YB"
    End If
End Function

' Return the value formatted to include at most three
' non-zero digits and at most two digits after the decimal
' point. Examples:
'         1
'       123
'        12.3
'         1.23
'         0.12
Private Function ThreeNonZeroDigits(ByVal value As Double) _
    As String
    If value >= 100 Then
        ' No digits after the decimal.
        ThreeNonZeroDigits = Format$(CInt(value))
    ElseIf value >= 10 Then
        ' One digit after the decimal.
        ThreeNonZeroDigits = Format$(value, "0.0")
    Else
        ' Two digits after the decimal.
        ThreeNonZeroDigits = Format$(value, "0.00")
    End If
End Function

